//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MsgBoxDlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMsgBoxDlg *MsgBoxDlg;
//---------------------------------------------------------------------------
int __fastcall MyMsgBox(TForm *Owner, AnsiString Message, AnsiString Caption, UINT Type)
{
   int result=0;
   MsgBoxDlg = new TMsgBoxDlg(Owner,Message,Caption,Type);
   MsgBoxDlg->ShowModal();
   switch (MsgBoxDlg->ModalResult)
   {
      case mrCancel: result = IDCANCEL; break;
      case mrYes: result = IDYES; break;
      case mrOk: result = IDOK; break;
      case mrNo: result = IDNO; break;
   }
   delete MsgBoxDlg;
   return result;
}
//---------------------------------------------------------------------------
int __fastcall BingMsgBox(TForm *Owner, AnsiString Message, AnsiString Caption, UINT Type)
{
   int result=0;
   MsgBoxDlg = new TMsgBoxDlg(Owner,Message,Caption,Type);
   MessageBeep(0);
   MsgBoxDlg->ShowModal();
   switch (MsgBoxDlg->ModalResult)
   {
      case mrCancel: result = IDCANCEL; break;
      case mrYes: result = IDYES; break;
      case mrOk: result = IDOK; break;
      case mrNo: result = IDNO; break;
   }
   delete MsgBoxDlg;
   return result;
}
//---------------------------------------------------------------------------
int __fastcall InfoBox(TForm *Owner, AnsiString Message, UINT Type)
{
   return MyMsgBox(Owner,Message,"Information",Type);
}
//---------------------------------------------------------------------------
int __fastcall ErrorBox(TForm *Owner, AnsiString Message, UINT Type)
{
   return BingMsgBox(Owner,Message,"ERROR",Type);
}
//---------------------------------------------------------------------------
int __fastcall NoticeBox(TForm *Owner, AnsiString Message, UINT Type)
{
   return MyMsgBox(Owner,Message,"NOTICE",Type);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TMsgBoxDlg::TMsgBoxDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMsgBoxDlg::TMsgBoxDlg(TComponent* Owner, AnsiString &message,
   AnsiString &caption, UINT type) : TForm(Owner)
{
   Caption = caption;
   TForm *owner = (TForm*)Owner;
   SetButtons(type); SetText(message);
   if (owner)
   {
      Position = poDesigned;
      Top = owner->Top+((owner->Height-Height)/2);
      Left = owner->Left+((owner->Width-Width)/2);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMsgBoxDlg::SetText(AnsiString &Text)
{
   int length,minwidth,longest=0,pos=-1,btnspace=8,btnwidth=Button1->Width;
   TStringList *msg = new TStringList(); msg->Text = Text;
   for (int i=0; i<msg->Count; i++)
   {
      length = msg->Strings[i].Length();
      if (length>longest)
      {
         longest = length;
         pos = i;
      }
   }
   if (pos>=0)
   {
      int bwidth = Panel2->BorderWidth;
      AnsiString line = msg->Strings[pos];
      ClientWidth = Canvas->TextWidth(line)+(bwidth*2);
      ClientHeight = ((Canvas->TextHeight("Dy"))*msg->Count)+(bwidth*2)+Panel1->Height;
   }

   Button3->Left = ClientWidth-(btnwidth+btnspace);
   Button2->Left = Button3->Left-(btnwidth+btnspace);
   Button1->Left = Button2->Left-(btnwidth+btnspace);
   switch (btncount)
   {
      case 1: minwidth = (btnwidth*1)+(btnspace*2); break;
      case 2: minwidth = (btnwidth*2)+(btnspace*3); break;
      case 3: minwidth = (btnwidth*3)+(btnspace*4); break;
   }
   if (ClientWidth<minwidth)
   {
      ClientWidth = minwidth;
      Button3->Left = ClientWidth-(btnwidth+btnspace);
      Button2->Left = Button3->Left-(btnwidth+btnspace);
      Button1->Left = Button2->Left-(btnwidth+btnspace);
   }

   TextBox->Lines->Text = msg->Text;
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TMsgBoxDlg::SetButtons(UINT type)
{
   if ((type & MB_YESNOCANCEL)==MB_YESNOCANCEL)
   {
      Button1->Visible = true;
      Button1->Caption = "Yes";
      //Button1->Default = true;
      Button1->ModalResult = mrYes;
      Button2->Visible = true;
      Button2->Caption = "No";
      Button2->ModalResult = mrNo;
      Button3->Visible = true;
      Button3->Caption = "Cancel";
      Button3->Cancel = true;
      Button3->ModalResult = mrCancel;
      btncount = 3;
   }
   else
   if ((type & MB_YESNO)==MB_YESNO)
   {
      Button2->Visible = true;
      Button2->Caption = "Yes";
      //Button2->Default = true;
      Button2->ModalResult = mrYes;
      Button3->Visible = true;
      Button3->Caption = "No";
      Button3->Cancel = true;
      Button3->ModalResult = mrNo;
      btncount = 2;
   }
   else
   if ((type & MB_OKCANCEL)==MB_OKCANCEL)
   {
      Button2->Visible = true;
      Button2->Caption = "Ok";
      //Button2->Default = true;
      Button2->ModalResult = mrOk;
      Button3->Visible = true;
      Button3->Caption = "Cancel";
      Button3->Cancel = true;
      Button3->ModalResult = mrCancel;
      btncount = 2;
   }
   else
   if ((type & MB_OK)==MB_OK)
   {
      Button3->Visible = true;
      Button3->Caption = "Ok";
      Button3->Default = true;
      Button3->ModalResult = mrOk;
      btncount = 1;
   }
}
//---------------------------------------------------------------------------
