//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <time.h>
#pragma hdrstop

#include "PgpKeyGenDoDlgs.h"
#include "PgpKeyGenDoThrds.h"
#include "Mixmaster.h"
#include "PGPbuffers.h"
#include "PgpFiles.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpKeyGenDoDlg *PgpKeyGenDoDlg;
//---------------------------------------------------------------------------
bool __fastcall DoGenerateRSAKey(TForm *Owner)
{
   PgpKeyGenDoDlg = new TPgpKeyGenDoDlg(Owner);
   CenterDialog(PgpKeyGenDoDlg,Owner);
   PgpKeyGenDoDlg->ShowModal();
   bool ok = PgpKeyGenDoDlg->ModalResult==mrOk;
   delete PgpKeyGenDoDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPgpKeyGenDoDlg::TPgpKeyGenDoDlg(TComponent* Owner)
  : TForm(Owner)
{
   pgpkeygen=(PGPKEYGEN)GetProcAddress(hMixLib,"pgp_keygen");
   userid = buf_new(); buf_sets(userid,"testname <testing@myusual.net>");
   passwd = buf_new(); buf_sets(passwd,"testing");
   lstrcpy(pubring,PgpPublicRing().c_str());
   lstrcpy(secring,PgpSecretRing().c_str());
   Timer1->Enabled = true;
   Timer2->Enabled = true;
   ImageList1->BkColor = Color;
   cap = Caption;
   clockpos = -1;
   keydone = false;
}
//---------------------------------------------------------------------------
__fastcall TPgpKeyGenDoDlg::~TPgpKeyGenDoDlg()
{
   buf_free(passwd);
   buf_free(userid);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDoDlg::Timer1Timer(TObject *Sender)
{
   clockpos++;
   if (clockpos<1) return;
   if (keydone) clockpos = 1;
   ImageList1->Draw(Canvas,(Width/2)-25,45,clockpos-1);
   if (clockpos==8) clockpos = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDoDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDoDlg::GenerateRSAkey()
{
   int result=-2;
   if (pgpkeygen!=NULL)
   {
      int algo=PGP_ES_RSA,remail=0,bits=1024;
      result = (pgpkeygen)(algo,bits,userid,passwd,pubring,secring,remail);
   }
   MsgBoxHwnd(Handle,"Result of generation: "+s(result),"Results",MB_OK);
   keydone = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDoDlg::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   GenerateRSAkey();
   Snooze(1);
   Close();
}
//---------------------------------------------------------------------------
/*void __fastcall TPgpKeyGenDoDlg::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;
   int result = GenerateRSAkey(hMixLib,1024,"testname <testing@myusual.net>",
     "testing",1);
   MsgBoxHwnd(Handle,"Result of generation: "+s(result),"Results",MB_OK);
   AppProcessMessages(); Sleep(300);
   Close();
}*/
//---------------------------------------------------------------------------
/*int __fastcall pgp_keygen(int algo, int bits, BUFFER *userid, BUFFER *pass,
   char *pubring, char *secring, int remail)
{
   int result = -2;
   PGPKEYGEN pgpkeygen;
   if ((pgpkeygen=(PGPKEYGEN)GetProcAddress(hMixLib,"pgp_keygen"))!=NULL)
   {
      result = (pgpkeygen)(PGP_ES_RSA,0,userid,pass,pubring,secring,0);
   }
   return result;
}*/
//---------------------------------------------------------------------------
